program test_read_eddy

  ! Library:
  use jumble, only: get_command_arg_dyn, read_opcol
  use shapelib_03, only: dbf_read_attribute_03

  use derived_types, only: eddy, shpc_slice_handler
  use read_eddy_m, only: read_eddy
  use shpc_close_m, only: shpc_close
  use shpc_create_m, only: shpc_create
  use shpc_open_m, only: shpc_open
  use write_eddy_m, only: write_eddy

  implicit none

  type(eddy) e
  integer k, eddy_i
  integer:: ishape = 0
  TYPE(shpc_slice_handler) hshp
  character(len = :), allocatable:: shpc_dir
  namelist /main_nml/ ishape

  !-------------------------------------------------------------------------

  call get_command_arg_dyn(1, shpc_dir, "Required argument: SHPC-directory")
  print *, "Enter namelist main_nml."
  read(unit = *, nml = main_nml)
  call shpc_open(hshp, shpc_dir, pszaccess = "rb")
  call dbf_read_attribute_03(hshp%d0, hshp%extremum, hshp%extr_date, ishape = 0)
  call read_opcol(hshp%ishape_last, hshp%unit, my_lbound = hshp%d0)
  call read_eddy(e, k, eddy_i, hshp, ishape)
  CALL shpc_close(hshp)

  call shpc_create(hshp, shpc_dir = "SHPC", cyclone = hshp%cyclone)
  call write_eddy(e, hshp, k, eddy_i)
  CALL shpc_close(hshp)
  print *, 'Created shapefiles in SHPC.'

end program test_read_eddy
